%{

/*
   timing.l -- PIKT piktd timing lexer

   $Header: /home/cvs/ucgsb/pikt/src/piktd/timing.l,v 1.10 1999/11/13 07:48:24 berto Exp $

   This file is part of PIKT ("Problem Informant/Killer Tool").
   Copyright (C) 1998-99 by Robert Osterlund.

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License
   as published by the Free Software Foundation; either version 2
   of the License, or (at your option) any later version.

   PIKT is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,
   USA.

   This product includes software developed by the University of
   California, Berkeley and its contributors.

   Send problem reports, bouquets and brickbats to:

   robert.osterlund@gsb.uchicago.edu

   Robert Osterlund
   Graduate School of Business
   University of Chicago
   1101 E. 58th Street, W309
   Chicago, IL 60637
   USA
 */

#include "../lib/common.h"

#include "piktd.h"
#include "timing.tab.h"

signed int timinginput(void);

#undef YY_INPUT
#define YY_INPUT(buf, result, max_size) { \
		signed char c = timinginput(); \
		result = (c == EOF) ? YY_NULL : (buf[0] = c, 1); \
	}

%}

W		[ \t]
D		[0-9]
L		[A-Za-z]
DL		[0-9A-Za-z]

%option noyywrap

%%

{D}+				{ timinglval.ival = atoi(yytext);
				  return _NUMBER;
				}

(\*|\-|\,|\/|\%)		{ return yytext[0]; }

.				{ return yytext[0]; }

%%

/* timing error handler
 */
void
timingerror (const char *message)
{

	logexit(PIKTLOG, LOG_ERR, __FILE__, __LINE__, FALSE, "%s (in timingparse()): @%s@", message, yytext ? yytext : "");
	return;
}

/* feed timing params to the input stream
 */
signed int
timinginput (void)
{
	char c;

	if (!*tcp) {
		return(EOF);
	}
	c = *tcp;
	tcp++;
	return(c);
}
